package cardealerapp;

public class Car {
    protected String model;
    protected int manufactureYear;
    protected double price;
    protected String color;
    protected String[] accessories;

    protected int[] yearRange;
    protected double[] priceRange;
    protected String[] availableColors;
    protected String[] availableAccessories;

    public int getManufactureYear() {
        return manufactureYear;
    }

    public void setManufactureYear(int manufactureYear) {
        if (manufactureYear >= yearRange[0] && manufactureYear <= yearRange[1]) {
            this.manufactureYear = manufactureYear;
            System.out.println("New Manufacture Year: " + manufactureYear);
        } else {
            System.out.println("Car Dealer works with only cars manufactured betwee " +
                yearRange[0] + " and " + yearRange[1]);
        }
    }

    public double getPrice() {
        return price;
    }

    public void setPrice(double price) {
        if (price >= this.priceRange[0] && price <= this.priceRange[1]) {
            this.price = price;
            System.out.println("New sale price: " + this.price);
        } else {
            System.out.println("New price cannot be set. It is outside profit margin.");
        }
    }

    public String getColor() {
        return color;
    }

    public void setColor(String newColor) {
        boolean hasColorChanged = false;
        for (String currentColor : availableColors) {
            if (newColor.equalsIgnoreCase(currentColor)) {
                this.color = newColor;
                hasColorChanged = true;
            }
        }
        if (hasColorChanged) {
            System.out.println("New color: " + this.color);
        } else {
            System.out.println("Color not available for this car model.");
        }
    }

    public String[] getAccessories() {
        return accessories;
    }

    public void setAccessories(String[] accessories) {
        String[] tempAccessories = new String[3];
        int index = 0;
        for (String newAccessory : accessories) {
            for (String availableAccessory : this.availableAccessories) {
                if (newAccessory.equalsIgnoreCase(availableAccessory)) {
                    tempAccessories[index] = newAccessory;
                    index++;
                }
            }
        }
        if (index != 0) {
            this.accessories = tempAccessories;
            System.out.print("New list of accessories: ");
            for (String accessory : accessories) {
                System.out.print(accessory + " ");
            }
            System.out.print("");
        } else {
            System.out.print("The list of new accessories are not valid.");
        }
    }
    
    public void printCarInfo() {
        System.out.println("Car Model: " + model);
        System.out.println("Built year: " + manufactureYear);
        System.out.println("Tag Price: " + price);
        System.out.println("Color: " + color);
        System.out.println("Accessories: " + getListOfAccessories());
    }
    
    private String getListOfAccessories() {
        String list = "";
        for (String item : accessories) {
            if (item != null) {
                list+= item + " ";
            }
        }
        return list;
    }
}
